package com.ejie.ab39a.dao;

import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JQGridManager;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;
import com.gfi.constants.Constants;
import com.gfi.utils.UtilSQL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import com.ejie.ab39a.model.Localidad;

/**
 * LocalidadDaoImpl.
 * 
 *  
 */

@Repository
@Transactional
public class LocalidadDaoImpl implements LocalidadDao {

	private static final String[] ORDER_BY_WHITE_LIST = new String[] { "ID_LOCALIDAD", "ID_MUNICIPIO", "ID_PROVINCIA",
			"DESC_OF" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Localidad> rwMap = new RowMapper<Localidad>() {
		@Override
		public Localidad mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Localidad(resultSet.getString("IDLOCALIDAD"), resultSet.getString("IDMUNICIPIO"),
					resultSet.getString("IDPROVINCIA"), resultSet.getString("DESCOF"));
		}
	};

	private RowMapper<Localidad> rwMapPK = new RowMapper<Localidad>() {
		@Override
		public Localidad mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Localidad(resultSet.getString("IDLOCALIDAD"), resultSet.getString("IDMUNICIPIO"),
					resultSet.getString("IDPROVINCIA"), resultSet.getString("DESCOF"));
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Localidad table.
	 *
	 * @param localidad
	 *            Localidad
	 * @return Localidad
	 */
	@Override
	public Localidad add(Localidad localidad) {
		StringBuilder query = new StringBuilder(
				"INSERT INTO LOCALIDAD (ID_LOCALIDAD,ID_MUNICIPIO, ID_PROVINCIA, DESC_OF) VALUES (?,?,?,?)");
		this.jdbcTemplate.update(query.toString(), localidad.getIdLocalidad(), localidad.getIdLocalidad(),
				localidad.getIdProvincia(), localidad.getDescOf());
		return localidad;
	}

	/**
	 * Updates a single row in the Localidad table.
	 *
	 * @param localidad
	 *            Localidad
	 * @return Localidad
	 */
	@Override
	public Localidad update(Localidad localidad) {
		StringBuilder query = new StringBuilder("UPDATE LOCALIDAD  SET ");
		query.append(" WHERE ID_LOCALIDAD=? AND ID_MUNICIPIO=? AND ID_PROVINCIA=? AND DESC_OF=?");
		this.jdbcTemplate.update(query.toString(), localidad.getIdLocalidad(), localidad.getIdMunicipio(),
				localidad.getIdProvincia(), localidad.getDescOf());
		return localidad;
	}

	/**
	 * Finds a single row in the Localidad table.
	 *
	 * @param localidad
	 *            Localidad
	 * @return Localidad
	 */
	@Override
	@Transactional(readOnly = true)
	public Localidad find(Localidad localidad) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));
		// WHERE
		query.append(
				" WHERE t1.ID_LOCALIDAD = ? AND t1.ID_MUNICIPIO = ?   AND t1.ID_PROVINCIA = ?   AND t1.DESC_OF = ?  ");

		List<Localidad> localidadList = this.jdbcTemplate.query(query.toString(), this.rwMap,
				localidad.getIdLocalidad(), localidad.getIdMunicipio(), localidad.getIdProvincia(),
				localidad.getDescOf());
		return DataAccessUtils.uniqueResult(localidadList);
	}

	/**
	 * Removes a single row in the Localidad table.
	 *
	 * @param localidad
	 *            Localidad
	 */
	@Override
	public void remove(Localidad localidad) {
		String query = "DELETE FROM LOCALIDAD WHERE ID_LOCALIDAD =? AND ID_MUNICIPIO=? AND ID_PROVINCIA=? AND DESC_OF=?";
		this.jdbcTemplate.update(query, localidad.getIdLocalidad(), localidad.getIdMunicipio(),
				localidad.getIdProvincia(), localidad.getDescOf());
	}

	/**
	 * Finds a list of rows in the Localidad table.
	 * 
	 * @param localidad
	 *            Localidad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Localidad>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Localidad> findAll(Localidad localidad, JQGridRequestDto jqGridRequestDto) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(localidad);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the Localidad table using like.
	 * 
	 * @param localidad
	 *            Localidad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Localidad>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Localidad> findAllLike(Localidad localidad, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(localidad, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query, LocalidadDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Localidad table.
	 * 
	 * @param localidad
	 *            Localidad
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(Localidad localidad) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM LOCALIDAD t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(localidad);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Localidad table using like.
	 * 
	 * @param localidad
	 *            Localidad
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Localidad localidad, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM LOCALIDAD t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(localidad, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Localidad selected for rup_table
	 * 
	 * @param localidad
	 *            Localidad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Localidad>>
	 */
	@Override
	public List<TableRowDto<Localidad>> reorderSelection(Localidad localidad, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(localidad, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings(value = "unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = JQGridManager.getReorderQuery(query, jqGridRequestDto, Localidad.class,
				filterParamList, "IDLOCALIDAD,IDMUNICIPIO, IDPROVINCIA, DESCOF");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Localidad>(this.rwMapPK, jqGridRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 * 
	 * @param filterLocalidad
	 *            Localidad
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Localidad filterLocalidad, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT - FROM
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterLocalidad, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings(value = "unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = JQGridManager.getRemoveMultipleQuery(jqGridRequestDto, Localidad.class,
				query, params, "IDLOCALIDAD,IDMUNICIPIO, IDPROVINCIA, DESCOF");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Devuelve la Select con todos los campos. Incluye el From si se indica.
	 * 
	 * @param includeFrom
	 *            boolean
	 * @return String
	 */
	private String getSelectFromQuery(boolean includeFrom) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_LOCALIDAD IDLOCALIDAD,t1.ID_MUNICIPIO IDMUNICIPIO, t1.ID_PROVINCIA IDPROVINCIA, t1.DESC_OF DESCOF ");
		if (includeFrom) {
			query.append(" FROM LOCALIDAD t1 ");
		}
		return query.toString();
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Localidad entity
	 * 
	 * @param localidad
	 *            Localidad Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Localidad localidad) {

		StringBuilder where = new StringBuilder(Constants.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (localidad != null) {
			if (localidad.getIdLocalidad() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.ID_LOCALIDAD", localidad.getIdLocalidad());
			}
			if (localidad.getIdMunicipio() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.ID_MUNICIPIO", localidad.getIdMunicipio());
			}
			if (localidad.getIdProvincia() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.ID_PROVINCIA", localidad.getIdProvincia());
			}
			if (localidad.getDescOf() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.DESC_OF", localidad.getDescOf());
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Localidad entity
	 * 
	 * @param localidad
	 *            Localidad Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	private Map<String, Object> getWhereLikeMap(Localidad localidad, Boolean startsWith) {

		StringBuilder where = new StringBuilder(Constants.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (localidad != null) {
			if (localidad.getIdLocalidad() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.ID_LOCALIDAD", localidad.getIdLocalidad(), startsWith);
			}
			if (localidad.getIdMunicipio() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.ID_MUNICIPIO", localidad.getIdMunicipio(), startsWith);
			}
			if (localidad.getIdProvincia() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.ID_PROVINCIA", localidad.getIdProvincia(), startsWith);
			}
			if (localidad.getDescOf() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.DESC_OF", localidad.getDescOf(), startsWith);
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
}
